/**
 * The Character class represents the main character of the game.
 */
function Character() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";
    this.name = "Moe";
    this.body = new Body();
    this.stats = new Stats();
    this.status = new Status();
    this.history = new History();
    this.inventory = new Inventory();

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this object from a type-stripped version thereof.
     * @param {Character-stripped} kobold A Character object, stripped of private members and all functions.
     */
    this.load = function (kobold) {
        that.name = kobold.name;
        that.body.load(kobold.body);
        that.stats.load(kobold.stats);
        that.status.load(kobold.status);
        that.history.load(kobold.history);
        that.inventory.load(kobold.inventory);
    };
}
