/**
 * What the kobold did during the third afternoon of Varanar.
 */
function AfternoonThreeShared() {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";

    this.massageParlor = false; // Went to the massage parlor.
    this.parlorBargainSuccess = false; // Successfully bargained the price down at the massage parlor.
    this.parlorRan = false; // Ran from the parlor.
    this.parlorFought = false; // Fought Tychus at the parlor.
    this.parlorKilled = false; // Killed Tychus at the parlor.
    this.parlorMassaged = false; // Massaged at the parlor.
    this.parlorArmMassage = false; // Massaged arms at the parlor.
    this.parlorFootMassage = false; // Massaged feet at the parlor.
    this.parlorBackMassage = false; // Massaged back at the parlor.
    this.parlorFreed = false; // Freed kobolds from the parlor. If combined with killed, the kobolds hate Moe.
    this.parlorKnockedOut = false; // Knocked out at the parlor.
    this.parlorInjured = false; // Injured by the post-massage at the parlor.

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Loads this object from a type-stripped version thereof.
     * @param {Shared-stripped} shared A Shared object, stripped of private members and all functions.
     */
    this.load = function (shared) {
        var defaults = new AfternoonThreeShared();
        if (!shared) {
            that.load(defaults);
            return;
        }
        for (var key in that) {
            if (typeof that[key] === "function") {
                continue;
            }
            that[key] = shared[key] || defaults[key];
        }
        for (var key in shared) {
            if (that[key] || !shared[key]) { // Already processed or don't need to process.
                continue;
            }
            that[key] = shared[key];
        }
    };
}