/**
 * Loading screen for the lockpicking minigame.
 * @param {string} id Scene id. Used to create controllers.
 * @param {string} key Unique key-space for the lockpicking minigame.
 */
function LockPickingLoadingScreen(id, key) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    
    var uniqueIdentifier = arguments.callee.name;
    var elementId = id + "_" + key + "_" + uniqueIdentifier;

    var visible = true;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    // PUBLIC MEMBERS \\        this.public = "test";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns the HTML.
     */
    this.build = function () {
        var element = `<div class="loadingscreen" ${!visible ? `style="display:none;"` : ``} id="${elementId}">Loading</div>`;
        return element;
    };

    /**
     * Registers all the required listeners.
     */
    this.registerListeners = function () {

    };

    /**
     * Preloads all assets required, if they have not yet already been loaded.
     */
    this.preload = function () {
        return new Promise(function (resolve, reject) {
            resolve();
        });
    };

    /**
     * Causes the element to fade out.
     */
    this.fade = function () {
        visible = false;
        $("#" + elementId).fadeOut(400);
    };
    
    /**
     * Causes the element to show.
     */
    this.show = function () {
        visible = true;
        $("#" + elementId).fadeIn(400);
    };
}

