/**
 * Steal section of the bandit encounter.
 * @param {ForestController} controller The forest controller.
 */
function ForestBanditSteal(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;
    
    var continueId = "banditStealContinueButton";
    
    var content = ` <div class="text">
                        Physically, you are no match for the group of kobolds.
                        If you got into a fight with them, they'd probably beat you up, 
                        stab you a couple of times and leave you for dead.
                        You <span class="bold">are</span>, however, 
                        just as cunning as they are, if not more so.
                        With all ten of their eyes focused on the aquamarine beauty,
                        you have no doubt that you'll be able to snatch at least <span class="italic">some</span> of their personal effects without getting noticed.
                    </div>
                    <div class="text">
                        You slip out from behind the tree trunk into the adjacent bush.
                        Luckily, the ruckus of the group's escalating gangrape covers up the rustling of leaves.
                        Still, you bide your time.
                        You don't want to attract <span class="bold">any</span> attention.
                        You play it cool.
                        You wait patiently, for any suspicion to fade.
                    </div>
                    <div class="text">
                        After a couple of minutes of remaining quiet and completely unnoticed,
                        you finally take a small step forwards, leaving your green concealment.
                        You are now in full view of the group of aroused males,
                        yet just as you suspected, just as you'd hoped, 
                        they are far too absorbed by their lust to notice you standing off to the side.
                    </div>
                    <div class="text">
                        You slowly inch forwards, 
                        step after step, 
                        until you reach the point where you're close enough to 
                        <span class="bold">smell</span> your fellow kobolds' excitement.
                        They've begun to properly <span class="bold">fuck</span> the dragoness,
                        their attention turned towards her waist, 
                        four of the males eagerly onlooking,
                        idly stroking themselves while waiting for the fifth to finish.
                    </div>
                    <div class="text">
                        Highly doubting the sexual stamina of a kobold bandit,
                        you realize you have to be quick about this.
                        In a bold and daring move,
                        you take a few quick large steps,
                        bringing you within grasping distance of the ringleader's discarded ${global.kobold.inventory.createItemWithTooltip(new LinenPants())}.
                        Taking a knee, you begin to quietly rifle through the pockets, finding them full of ill-gotten coins.
                    </div>
                    <div class="text">
                        Various moans, grunts, jests and jeers muffle the jangling noise of coins being stolen.
                        After taking two big handfuls and adding them to your own purse, you come across an odd find.
                        Apparently, the bandit saw fit to keep a key in his pocket, amidst all of the gold.
                        While you have no clue as to what lock this key may fit, you take it anyway.
                    </div>
                    <div class="text">
                        Judging by his increasingly rabid thrusts, 
                        you don't think the kobold fucking the dragoness'll last much longer.
                        While the urge to grab just a few more coins is tempting,
                        you decide not to push your luck any further than you already have.
                        You pussyfoot your way out of the clearing.
                        As you slip back into the treeline, 
                    </div>
                    <div class="text">
                        You pussyfoot your way out of the clearing.
                        As you slip back into the treeline, 
                        you cast one last glance at the dragoness,
                        just in time to witness the first of her rapists pull out,
                        a meagre dribble of spunk immediately oozing from her innards.
                        The spent kobold, 
                        in the middle of enjoying the afterglow of a good fuck,
                        gets pushed out of the way by one of his friends,
                        only to be replaced by the second in line.
                    </div>
                    <div class="text">
                        You head further into the woods, out of sight of the gang.
                        You wonder how long it'll take for them to realize they've just been robbed.
                        They probably won't even find out until after they've all finished having their turn with the dragoness.
                        By then, you'll be long gone.
                    </div>
                    <div class="text">
                        The sun is slowly setting.
                        Day is turning into night.
                        After counting your loot,
                        you decide to head home.
                    </div>`;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the continue button.
     */
    function buildChoice() {
        var disabled = ctrl.bandit.watch.stealHasContinued();
        var choice = `<button class="button bigbutton continuebutton" id="${continueId}" ${disabled ? "disabled" : ""}>`;
        choice += `Continue &gt;&gt`;
        choice += `</button>`;
        return choice;
    }
    
    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }
    
    /**
     * Loads and displays the next part.
     */
    function loadNextPart() {
        global.ui.fadeOutContent(function () {
            global.sceneEnd();
            global.sceneLoader.loadScene(ctrl.homeSceneName);
        });
    }
    
    /**
     * Adds a listener to the continue button.
     */
    function registerContinueListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.bandit.watch.stealContinue();
            loadNextPart();
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = "banditSteal";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.bandit.watch.getWatchChoice() !== ForestBanditWatchChoiceEnum.STEAL) {
            return "";
        }
        ctrl.bandit.watch.stealShared();
        var change = ctrl.bandit.watch.stealItems();
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += content;
        part += change;
        part += buildChoice();
        part += `</div>`;
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.bandit.watch.getWatchChoice() !== ForestBanditWatchChoiceEnum.STEAL) {
            return;
        }

        // Register child listeners here

        if (ctrl.bandit.watch.stealHasContinued()) {
            return;
        }

        registerContinueListener();
    };
}
