/**
 * Massage section of Varanar, Afternoon Three.
 * @param {AfternoonThreeParlorController} controller The Varanar, Afternoon Three controller.
 */
function AfternoonThreeParlorArms(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var reqChoice = AfternoonThreeParlorMassageChoice.ARMS;
    var reqController = ctrl.massage;
    var subController = ctrl.postMassage;
    var changeController = ctrl.arms;

    var autoContinue = false;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = ctrl.fragments.postMassage;

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.dayThree.afternoon.parlorArmMassage = true;
        var startBoy = global.kobold.history.scenes["Introduction"].gender;
        var bargainSuccess = global.kobold.history.shared.varanar.dayThree.afternoon.parlorBargainSuccess;
        var free = ctrl.entrance.get() === AfternoonThreeParlorEntranceChoice.DECLINE || ctrl.bargain.get() === AfternoonThreeParlorEntranceChoice.DECLINE;
        var toReturn = `[p]
                            An arm massage might be nice.
                            You're always carrying around a bunch of stuff and lifting heavy things and climbing stuff.
                            All of this has lead to a constant, dull pain building up in your lower arms,
                            which makes doing anything with your hands a little more frustrating than it used to be.
                            If Orange could fix or [i]alleviate[/i] those pains a little, you'd love her forevermore,
                            and you'd undoubtedly come back for a second massage after you've scrounged together enough money.
                        [/p]
                        [p]
                            You don't know enough about massaging to know whether or not a simple rubdown [i]can[/i] fix your ailments,
                            but instead of confirming or denying, the orange-scaled kobold simply gestures towards the nearest massage table,
                            and gives you a small wink, as if wordlessly saying to let her work her magic.
                        [/p]
                        [p]
                            You eagerly clamber ontop of the wooden table, and lay yourself down ontop of it, belly-down.
                            This thing was obviously built for species [b]far[/b] bigger than you are.
                            You scoot upwards, until your head ends up resting atop a soft pillow at the far end of the wooden surface.
                            Once comfortable, you spread eagle, giving your massseuse plenty of access to your arms.
                            Orange climbs up as well, with a bit more tact, style and grace than you.
                            She [i]is[/i] a professional, after all.
                            Or maybe she's just done this enough to know how to get ontop of the table without looking like an idiot.
                        [/p]
                        [p]
                            After coating her hands in massage oil,
                            your masseuse drops to her knees,
                            and begins the massage by smoothly stroking both your arms from your wrist all the way up to your shoulders,
                            slathering your limbs in clear, lubricating liquid.
                            Pleasant, but not overly so.
                            Then again, the real massage hasn't even begun.
                        [/p]
                        [p]
                            Speak of the devil, Orange takes hold of one of your upper arms, and begins to [b]knead[/b] it,
                            pleasantly digging her soft, oil-coated palms into your muscles, loosening and relaxing them.
                            It feels [b]divine[/b]!
                            Like all the stress and fatigue built up from all the work you've ever done is melting away.
                            And the kobold is only getting started.
                        [/p]
                        [p]
                            Your lower arm is next.
                            Orange presses her slickened hands against your scales, and begins to rub around in small, circular motions,
                            grinding her palms into your flesh, almost making you [b]squeal[/b] in pure ecstacy.
                            It feels [b]so[/b] good!
                            It's like all your worries and pain are [b]washed away[/b] under the tide of massage oil slathered about by
                            her soft and gentle, yet surprisingly firm touch.
                        [/p]
                        [p]
                            The dull pain you once felt fades away, replaced by sheer bliss.
                            Your masseuse rises to her feet, placing one foot on your back to hold you in place,
                            while [b]tugging[/b] your arm towards her.
                            A small [i]crack[/i] resonates throughout the room, followed by an almost [i]sexual[/i] moan.
                            Absolutely [b]amazing[/b]!
                        [/p]
                        [p]
                            Your face sinks deeper into the pillow you're laying on, as Orange proceeds to service your [i]other[/i] arm.
                            If you'd known getting a massage felt [b]this[/b] incredible, you'd have
                            ${bargainSuccess || free ? `gladly paid full price` : `coughed up fourty coins a lot quicker`}.
                            Soothed by the near-orgasmic goodness coursing down your spine, you close your eyes, and slowly drift away in pleasure.
                        [/p]
                        [p]
                            "[color=orange]Time's up![/color]" comes Orange's heavenly voice, far earlier than you would have expected it.
                            You must have dozed off a little, or maybe time really does go by faster when you're having fun.
                            Either way, your arms haven't felt this good since you were a little ${startBoy ? `boy` : `girl`}.
                            It really does feel like you were born anew.
                        [/p]
                        [p]
                            You run one of your own hands over your oily bi- and triceps.
                            With your muscles loosened, your arms feels more supple, yet also [b]stronger[/b].
                            Like the massage has renewed your strength,
                            or perhaps brought out some of that [i]inner power[/i] priests and clerics always rant on about.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = subController.continued() ? "disabled" : "";
        var isSelected = subController.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            subController.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return "";
        }

        if (autoContinue) {
            subController && subController.continue();
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += (changeController && changeController.change()) || "";
        part += (!autoContinue && buildChoice()) || "";
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (reqController && ((reqChoice && reqController.get() !== reqChoice) || (!reqChoice && !reqController.continued()))) {
            return;
        }

        next.registerListeners();

        if (!subController || subController.continued()) {
            return;
        }

        registerNextListener();
    };
}
