/**
 * Confrontation section of Varanar, Night Two.
 * @param {NightTwoController} controller The Night Two controller.
 */
function NightTwoCrudeStruggle(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new NightTwoCrudeStruggleContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.nightTwo.forced = true;
        global.kobold.history.shared.varanar.nightTwo.buttKiss = true;
        var toReturn = `[p]
                            You wriggle around, attempting to escape the human's grasp,
                            but all he has to do is apply some extra [b]force[/b] to halt your squirming.
                            Your arm feels like it's about to [b]break[/b].
                            The pain almost makes you burst into tears, yet you manage to save face for just a little while longer.
                            Your mind [b]screams[/b] for you to beg him to let go, but you don't want to humiliate yourself any further.
                        [/p]
                        [p]
                            Your head gets gradually pushed lower and lower, closer to the hulking brute's bare behind.
                            "[color=bred]Hurry up back there, I haven't got all night.[/color]" he complains,
                            slightly bending over to make his ass just out further, its unsavory fragrance reaching your nose.
                            "[color=purple]You heard him, lizard.
                            Here you go.[/color]" the man holding your arm speaks.
                            Then, the slow, constant lowering is replaced by a single fierce [b]shove[/b],
                            your face forcibly pressed against the exposed delinquent's rear.
                        [/p]
                        [p]
                            Whether by accident, or just as planned, your muzzle ends up lodged directly in between the drunkard's buttcheeks,
                            warm, sweaty, hairy flesh enveloping your scales from all sides.
                            Your lips end up pressing directly against his [i]least sanitary[/i] part.
                            You make the mistake of gasping in surprise,
                            inadvertently taking in a mouthful and a noseful of the foul, concentrated stench of the human's butthole,
                            an intense feeling of [b]sickness[/b] building inside of you.
                        [/p]
                        [p]
                            The group goes wild.
                            Half of them burst out into laughter, the other half start to ridicule you,
                            hurling every insult they know your way in an attempt to make your life even more [b]miserable[/b] than it already is.
                            Your free arm gets grabbed, and held in place much like the other.
                            Your tail gets harshly yanked as a prank.
                            You don't know what brings more tears to your eyes:
                            the foul act you're forced to perform, or the oh-so-casual cruelty and complete disregard of your well-being.
                            You're nothing but an [b]animal[/b] to these people.
                        [/p]
                        [p]
                            You struggle with all of your might, yet the grip on your arms and on your head is unyielding.
                            You thought they just wanted you to give a peck on his buttcheek, not [b]this[/b]!
                            If you knew they wanted you to kiss his [b]asshole[/b], you'd have [b]fought them[/b] with a bit more [b]conviction[/b]!
                            But it's too late for that now.
                            You're completely trapped.
                            And as the humans so kindly remind you:
                            "[color=brown]You ain't gettin' out 'till you kiss it![/color]"
                        [/p]
                        [p]
                            Crying out loud, you swallow what little remains of your pride.
                            Puckering your lips, you plant a single, small kiss atop the half-naked human's hole,
                            and begin to [b]retch[/b] and [b]gag[/b] immediately afterwards.
                            "[color=bred]The lizard did it![/color]" the drunkard exclaims, and immediately you are yanked from his rear,
                            tossed to the ground like a used piece of toilet paper.
                            The moment your body hits the cold, hard dirt, you curl up into a ball and begin to cry your eyes out.
                        [/p]
                        [p]
                            Some of the humans taunt and humiliate you, but luckily,
                            most of them are more interested in the fact that the [i]bet[/i] between Jacoby and Jehova has been settled.
                            You tune out for a little while, not interested in what they, or anyone, for that matter has to say.
                            After a bit of rowdy discussion, the group sets off towards the brothel district, leaving you to wallow in self-pity.
                        [/p]`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = ctrl.crudeStruggle.continued() ? "disabled" : "";
        var isSelected = ctrl.crudeStruggle.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.crudeStruggle.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        if (ctrl.rude.get() !== NightTwoCrudeRudeChoice.STRUGGLE) {
            return "";
        }

        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.crudeStruggle.change();
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        if (ctrl.rude.get() !== NightTwoCrudeRudeChoice.STRUGGLE) {
            return;
        }

        next.registerListeners();

        if (ctrl.crudeStruggle.continued()) {
            return;
        }

        registerNextListener();
    };
}
