/**
 * Flee section of Varanar, Night Two.
 * @param {NightTwoController} controller The Night Two controller.
 */
function NightTwoRunSurvival(controller) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var ctrl = controller;

    var continueId = arguments.callee.name + "ButtonOne";
    var next = new NightTwoRunSurvivalContinue(ctrl);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Builds and returns the content of this section.
     * @returns {string} The content.
     */
    function buildContent() {
        global.kobold.history.shared.varanar.nightTwo.beatUp = true;
        var toReturn = `[p]
                            Desperate to get away from the men, you burst into a sprint the moment you turn a corner,
                            hoping to be able to outrun them before they even [i]know[/i] you're escaping.
                            While your gambit does pay off in the form of a head start, sadly, you don't manage to shake the group from the get-go.
                            Noticing their lizard-prey running away,
                            the men drop their tight-packed group-cohesion and begin to outright [b]chase[/b] after you.
                        [/p]
                        [p]
                            You run from street to street, periodically checking behind you to make sure they haven't given up yet.
                            While far bigger than you, and probably able to outrun you whilst sober, their heavy inebriation hinders the belligerent group significantly.
                            A couple of pursuers tumble over their own feet, falling to the ground, being left behind by their peers.
                            A few of the men get too sick to keep pursuing you, retreating into alleyways to empty their bellies of food and drink.
                            Some of them are simply too weary to keep up pursuit.
                            Initially numbering high in the single-digits,
                            it takes only a few solid minutes of running for their [i]pack[/i] to be reduced to three hard-boiled men.
                        [/p]
                        [p]
                            But still, even [b]one[/b] of them can [b]cave your head in[/b] if they manage to catch you.
                            You aren't out of the woods until you can shake off [b]all three[/b] of them.
                            And you get the feeling that all this running is making them [b]even more frustrated[/b].
                            There's no doubt in your mind: your very life is at stake here.
                            And the humans chasing you are [b]determined[/b] to rid their city of another [b]pest[/b] infesting it.
                        [/p]
                        [p]
                            You push your body to its very limits, sprinting away as fast as you can.
                            You can't hold out for much longer.
                            You can feel the end of your rope approaching.
                            You hope they're every bit as tired as you are.
                            That their bodies are as much on the verge of collapsing as your tiny, scaled frame is.
                        [/p]
                        [p]
                            Crossing into a more dignified area of Varanar, one of the few districts with cobblestone roads,
                            you feel the last of your energy leaving your body.
                            You try to keep running, you [b]really[/b] do, but your legs simply can no longer carry you.
                            As the flat dirt under your feet suddenly makes way for a more uneven, rock-like surface,
                            you lose your balance and plummet to the ground.
                            Time itself seems to slow down as your body falls limply onto the cold, hard street, completely exhausted.
                        [/p]
                        ${global.ui.condFail(`Insufficient stamina`)}
                        [p]
                            You roll onto your side right on time to witness one of your pursuers rapidly approaching.
                            Using the hefty momentum from his drunken running as a catalyst, he cruelly plants the tip of his heavy boot into your stomach,
                            kicking you [b]so[/b] hard your leathery body is lifted off the ground as a whole.
                            You scream in agony as you are hurled through the air, your panicked shout coming to an end as you fall down once more,
                            your frame heavily impacting with the stone street a second time, painfully skimming across it for a few more inches before finally coming to rest.
                        [/p]
                        [p]
                            Seriously hurt, you clutch your abdomen and slowly curl up into a ball.
                            You're pretty certain the [b]immense[/b] force behind the kick [b]broke[/b] something inside of you.
                            As you whimper and cry, the other two men that were chasing you catch up with their peer.
                            They advance upon you, and waste no time in resuming their brutal clobbering.
                        [/p]
                        [p]
                            One of them leans down, and mercilessly begins to [b]pound[/b] your side, battering your ribs with blow after blow of his powerful, clenched fist.
                            A second human begins to repeatedly kick your back with all of his might, your spine on the verge of [b]snapping[/b] in half.
                            The third and final abuser concerns himself with your face,
                            alternating between using his hands and his shoe-clad feet to batter every part of your visage from your forehead to your snout.
                        [/p]
                        [p]
                            You [b]beg[/b] for mercy, but the humans seem determined not to stop until you're [b]dead[/b].
                            Your eyes are beaten shut to the point where you can no longer [b]see[/b],
                            but you [b]hear[/b] someone walking by over the gut-wrenching sounds of your bones breaking and your scales bruising.
                            You cry out for help, hoping it's a kind-hearted guard, yet the clacking of spurred boots on stone don't cease, not even for an instant.
                            Help a kobold?
                            Why would he?
                        [/p]
                        [p]
                            For several minutes, all you know is agony.
                            Every square inch of your body not covered by your cowering arms is viciously attacked.
                            Your ribs are smashed, your nose is broken,
                            your back is [b]pelted[/b] with a barrage of blows and even the back of your head endures more than a few beatings.
                            As a final kick hits you square in the stomach, on the exact same spot as the very first one did, you are sent into a coughing fit,
                            hacking up bloody phlegms from the depths of your injured lungs.
                        [/p]
                        [p]
                            The three burly men are panting.
                            Exhausted, they wipe your own blood off onto your scales.
                            One of them cruelly spits in your face.
                            They're done, [b]for now[/b].
                        [/p]
                        [p]
                            Your abusers hurl various insults at you as they walk away, but you're too far [i]gone[/i] to really pay them much mind.
                            Teetering on the edge of consciousness, on the very brink of [b]death[/b],
                            you try to escape the crippling pain clouding your mind by focusing on your breathing,
                            but even the slight motion of your chest inflating and deflates sends spikes of [b]torment[/b] down your spine.
                            You've been hurt before, but never [b]this[/b] bad.
                            Blood oozes from your battered muzzle as you quietly sob away the immense anguish.
                        [/p]
                        ${global.ui.condSucc(`Sufficient health and endurance`)}`;

        return global.parser.parse(toReturn);
    }

    /**
     * Builds and returns the choice button.
     */
    function buildNextChoice() {
        var disabled = ctrl.runSurvive.continued() ? "disabled" : "";
        var isSelected = ctrl.runSurvive.continued();
        var selected = isSelected ? "selected" : "";
        var button = `<button class="button inlinechoice ${selected}" id="${continueId}" ${disabled}>Continue</button>`;
        return button;
    }

    /**
     * Builds and returns the choice of this section.
     * @returns {string} The choice of this section.
     */
    function buildChoice() {
        var choice = `<div class="choicecontainer">`;
        choice += buildNextChoice();
        choice += `</div>`;
        return choice;
    }

    /**
     * Disables all three buttons.
     */
    function disableButtons() {
        var buttons = [$("#" + continueId)];
        buttons.forEach(function (button) {
            button.unbind();
            button.attr("disabled", true);
        });
    }

    /**
     * Loads and displays the next part.
     * @param {object} part Which part to load.
     */
    function loadNextPart(part) {
        var built = part.build(true);
        global.ui.appendBeforeFinisher(built, global.ui.genericHeaderId);
        $("#" + part.id).fadeIn(400);
        part.registerListeners();
    }

    /**
     * Adds a listener to the button.
     */
    function registerNextListener() {
        $("#" + continueId).click(function () {
            $(this).addClass("selected");
            disableButtons();
            ctrl.runSurvive.continue();
            loadNextPart(next);
        });
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.id = arguments.callee.name;

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns this part.
     * @param {boolean} invisible If passed and true, will give the entire section a display:none style.
     */
    this.build = function (invisible) {
        var part = `<div id="${that.id}" ${invisible ? 'style="display:none;"' : ""}>`;
        part += buildContent();
        part += ctrl.runSurvive.change();
        part += buildChoice();
        part += `</div>`;
        part += next.build();
        return part;
    };

    /**
     * Registers all the required button listeners for this part.
     */
    this.registerListeners = function () {
        next.registerListeners();

        if (ctrl.runSurvive.continued()) {
            return;
        }

        registerNextListener();
    };
}
